;;;; javahack.scm


(define java:*cache-enabled* #t)

(define-macro (java-enable-cache flag)
  (set! java:*cache-enabled* (eq? flag 'on)) 
  '(void) )

(define-macro (java x)
  (let ((x (if (string? x) (string->symbol x) x)))
    (if (and java:*cache-enabled* 
	     (let ((str (symbol->string x)))
	       (not (char=? #\$ (string-ref str (sub1 (string-length str))))) ) )
	`(java-memoize ',(gensym) (lambda () (java-send ',x)))
	`(java-send ,(list 'quasiquote x)) ) ) )
